library(quantreg)
library(foreign)

setwd("C:/Users/rothe/Documents/My Dropbox/Papers/Misspecification Test for Conditional Distributional Models/Simulations")
##setwd("d:/benutzer/wied/dokumente/my dropbox/my dropbox/Misspecification test for conditional distributional models/simulations")
#setwd("D:/Sicherung/Dominik/Arbeit Uni/Dropbox/Misspecification Test for Conditional Distributional Models/simulations")
source("locscale.test3.r")
source("dr.test2.r")
source("qr.test2.r")
source("eg-qr.test.r")


bsrep <- 19
reps <- 1000

trim <- rbind(c(1e-5,1 - 1e-5),c(.1,.9),c(.1,.5),c(.5,.9))
ssize <- c(500,2000)

if (!file.exists("empirical.Rdata")){
pval <- list(NA)
for (i in 1:(3*4*2)) { pval[[i]] <- matrix(NA,ncol=12,nrow=reps)}
save(pval,file="empirical.Rdata")
} else {
load("empirical.Rdata")
}



cps88 <- read.dta("cps88.dta")

cps88 <- cps88[cps88[,"female"]==0,]

cps88[,"nind"] <- as.factor(cps88[,"nind"])
cps88[,"nocc"] <- as.factor(cps88[,"nocc"])
cps88[,"wage"] <- log(cps88[,"wage"])

ww <- cps88[,"eweight"] * cps88[,"uhrswk"]
ww <- ww/sum(ww)


dgp <- function(model) {

if (model ==1) {form <- wage ~ covered +educ + exper }
if (model ==2) {form <- wage ~ covered +educ + exper + I(exper^2) + educ*exper + married + partt + nonwhite + smsa}
if (model ==3) {form <- wage ~ covered +educ + exper + I(exper^2) + educ*exper + married + partt + nonwhite + smsa+nocc +nind}

form

}

for (i in 1:10000) {
 
   nval    <- 2#sample(1:2,1)
   trimval <- 1#sample(1:4,1)
   model   <- 3#sample(1:3,1)
  
   
   daten.sim <- model.frame(dgp(model), cps88[sample(1:74661,replace=FALSE,size=ssize[nval], prob = ww),], drop.unused.levels = TRUE)
   
   if (trimval==2) {
    daten.sim <- daten.sim[daten.sim[,"wage"] > log(3.75),]
   
   }
   
   

 #test1 <- (KhmaladzeTest(dgp(model),data=daten.sim,trim=trim[trimval,], nullH="location"))
 #test2 <- (KhmaladzeTest(dgp(model),data= daten.sim,trim=trim[trimval,], nullH="location-scale"))
 #test3 <- (locscale.test2(formula=dgp(model), dat= daten.sim, scaletest=FALSE, bsrep=bsrep)) 
 #test4 <- (locscale.test2(formula=dgp(model), dat =daten.sim, scaletest=TRUE, bsrep=bsrep)) 
 test5 <- (qr.test1(formula=dgp(model),dat= daten.sim, bsrep=bsrep))
 test6 <- (dr.test1(formula=dgp(model),dat= daten.sim, bsrep=bsrep))
 #test7 <- (eg.lqr.test(formula=dgp(model),dat= daten.sim, bsrep=bsrep))
 
 output <- list(test5,test6) 
 
 out <- rep(NA,12)

 #out[1] <- output[[1]]$Tn
 #out[2] <- output[[2]]$Tn
 out[3:4] <- c(output[[1]]$pval.ks,output[[1]]$pval.cvm)
 out[5:6] <- c(output[[2]]$pval.ks,output[[2]]$pval.cvm)
 #out[7:8] <- c(output[[3]]$pval.ks,output[[3]]$pval.cvm)
 #out[9:10] <- c(output[[6]]$pval.ks,output[[6]]$pval.cvm)
 #out[11:12] <- c(output[[7]]$pval.ks,output[[7]]$pval.cvm)
 
 load("empirical.Rdata")  
 stand <- which(is.na( pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,3] ))[1]
 pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][stand,] <- out
 save(pval,file="empirical.Rdata")  

 print(c(stand,nval,trimval,model))
    print(c(mean(pval[[2]][,4]<=.1, na.rm=TRUE),mean(pval[[2]][,6]<=.1, na.rm=TRUE)))

}

